Attribute VB_Name = "FOutLine"
Option Explicit

'---------------------
'ȉ΂炭API`
Public Declare Sub RtlMoveMemory Lib "kernel32" (Destination As Any, Source As Any, ByVal Length As Long)
Public Declare Function GetGlyphOutline Lib "gdi32" Alias "GetGlyphOutlineA" (ByVal hdc As Long, ByVal uChar As Long, ByVal fuFormat As Long, lpgm As GLYPHMETRICS, ByVal cbBuffer As Long, lpBuffer As Any, lpmat2 As MAT2) As Long
Public Const GGO_NATIVE = 2
Public Const TT_PRIM_LINE = 1
Public Const TT_PRIM_QSPLINE = 2

Declare Function Polyline Lib "gdi32" (ByVal hdc As Long, lpPoint As POINTAPI, ByVal nCount As Long) As Long
Declare Function PolylineTo Lib "gdi32" (ByVal hdc As Long, lppt As POINTAPI, ByVal cCount As Long) As Long
Declare Function PolyBezier Lib "gdi32" (ByVal hdc As Long, lppt As POINTAPI, ByVal cPoints As Long) As Long
Declare Function PolyBezierTo Lib "gdi32" (ByVal hdc As Long, lppt As POINTAPI, ByVal cCount As Long) As Long
Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long
Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
Declare Function CreateFontIndirect Lib "gdi32" Alias "CreateFontIndirectA" (lpLogFont As LOGFONT) As Long
Type LOGFONT
        lfHeight As Long
        lfWidth As Long
        lfEscapement As Long
        lfOrientation As Long
        lfWeight As Long
        lfItalic As Byte
        lfUnderline As Byte
        lfStrikeOut As Byte
        lfCharSet As Byte
        lfOutPrecision As Byte
        lfClipPrecision As Byte
        lfQuality As Byte
        lfPitchAndFamily As Byte
        lfFaceName(31) As Byte
End Type

Type POINTAPI
        X As Long
        Y As Long
End Type
Type FIXED
        fract As Integer '
        Value As Integer '
End Type
Type POINTFX
        X As FIXED
        Y As FIXED
End Type

Type GLYPHMETRICS
        gmBlackBoxX As Long
        gmBlackBoxY As Long
        gmptGlyphOrigin As POINTAPI
        gmCellIncX As Integer
        gmCellIncY As Integer
End Type
Type MAT2
        eM11 As FIXED
        eM12 As FIXED
        eM21 As FIXED
        eM22 As FIXED
End Type
Type TTPOLYCURVE
        wType As Integer
        cpfx As Integer
        apfx As POINTFX
End Type
Type TTPOLYGONHEADER
        cb As Long
        dwType As Long
        pfxStart As POINTFX
End Type


'-------------------------------
'ȉŒ`


Type PointSingle
  X As Single
  Y As Single
End Type

'P̃J[u
Type FOCurve
  CType As Long          'Ȑ̃^Cv 1|܂A2|XvC
  numPoint As Long       '_̐
  Point() As PointSingle '_̔z
End Type

'P̃ubN
Type FOBlock
  StartPoint As PointSingle  'ubN̎n_
  numCurve As Long           'J[u̐
  Curve() As FOCurve         'J[u̔z
End Type
  
'AEgC
Type FontOutline
  Char As String             'Ώۂ̕i1j
  NumBlock As Long           'ubN
  Block() As FOBlock         'ubN̔z
  MaxPoints As Long          'Ƃ_J[u̐_̐Bi`掞Ɏgpj
End Type

Private Function FtoS(f As FIXED) As Single
'FIXEĎŒ菬_Single
Dim s As Single
Dim i As Long

s = f.Value
i = f.fract
If i < 0 Then i = &H10000 + i
FtoS = s + CSng(i) / &H10000

End Function


Public Function GetOutline(ByVal hdc As Long, ByVal Char As String, ByRef lfnt As LOGFONT) As FontOutline
Dim FO As FontOutline
Dim Buf() As Byte
Dim ttph As TTPOLYGONHEADER
Dim ttpc As TTPOLYCURVE
Dim gm As GLYPHMETRICS
Dim m As MAT2
Dim bufsize&, offset&, i&, j&, k&, maxsize&
Dim pf As POINTFX
Dim t$
Dim nb&, nc&
Dim hfnt&
Dim rs!

'擪̕ΏۂƂ
If Len(Char) < 1 Then Exit Function
t = Left(Char, 1)

'tHgTCYƓ錋ʂςɂȂ̂
'傫߂̒lw肵Ăčswŏk
If lfnt.lfHeight <= 1 Then Exit Function
rs = 1 / lfnt.lfHeight

m.eM11.Value = 1
m.eM22.Value = 1

'Asc͕t̒lԂ߁AȂ̒lɕϊ
i = Asc(t)
If i < 0 Then i = &H10000 + i

'tHgw
hfnt = SelectObject(hdc, CreateFontIndirect(lfnt))

'Kvȃobt@TCY擾
bufsize = GetGlyphOutline(hdc, i, GGO_NATIVE, gm, 0, vbNullString, m)

If bufsize <= 0 Then
  Call DeleteObject(SelectObject(k, hfnt))
  Exit Function
End If

'ۂɃf[^擾
ReDim Buf(bufsize - 1) As Byte
Call GetGlyphOutline(hdc, i, GGO_NATIVE, gm, bufsize, Buf(0), m)
Call DeleteObject(SelectObject(k, hfnt))

'I[ɂǂ蒅܂ŌJԂ
nb = 0
Do While offset < bufsize

  'VubN쐬
  FO.NumBlock = FO.NumBlock + 1
  ReDim Preserve FO.Block(FO.NumBlock - 1) As FOBlock
  nb = FO.NumBlock - 1
  
  'ubÑwb_擾
  Call RtlMoveMemory(ttph, Buf(offset), Len(ttph))
  maxsize = offset + ttph.cb
  offset = offset + Len(ttph)
  
  '̃ubN̑ΉoCg܂œǂ݂
  With FO.Block(nb)
  
    'Jn_
    .StartPoint.X = FtoS(ttph.pfxStart.X) * rs
    .StartPoint.Y = FtoS(ttph.pfxStart.Y) * rs
    
    Do While offset < maxsize And offset < bufsize
      'J[u쐬
      .numCurve = .numCurve + 1
      ReDim Preserve .Curve(.numCurve - 1) As FOCurve
      nc = .numCurve - 1
            
      'J[ũwb_擾
      Call RtlMoveMemory(ttpc, Buf(offset), 4)
      offset = offset + 4
      .Curve(nc).CType = ttpc.wType
      .Curve(nc).numPoint = ttpc.cpfx
      ReDim .Curve(nc).Point(.Curve(nc).numPoint - 1) As PointSingle
      If FO.MaxPoints < ttpc.cpfx Then FO.MaxPoints = ttpc.cpfx
      
      '_擾
      For j = 0 To ttpc.cpfx - 1
        Call RtlMoveMemory(pf, Buf(offset), Len(pf))
        offset = offset + Len(pf)
        .Curve(nc).Point(j).X = FtoS(pf.X) * rs
        .Curve(nc).Point(j).Y = FtoS(pf.Y) * rs
      Next
    Loop
  End With
Loop

FO.Char = t
GetOutline = FO

End Function

Sub DrawOutline(ByVal hdc As Long, FO As FontOutline, ByVal X As Single, ByVal Y As Single, Optional DScale As Single = 1, Optional YMirror As Boolean = True, Optional ByVal Color As Long = vbBlack, Optional ByVal Width As Long = 1, Optional ByVal DrawStyle As Long = 0, Optional ByVal DrawBlock As Long = -1)
Dim oldPen&
Dim p() As POINTAPI
Dim lp As PointSingle, ps(3) As PointSingle
Dim i&, j&, k&, l&, s!


'y쐬
oldPen = SelectObject(hdc, CreatePen(DrawStyle, Width, Color))

i = FO.MaxPoints + 1
If i < 3 Then i = 3
ReDim p(i) As POINTAPI

'eubN̕`
For i = 0 To FO.NumBlock - 1
  'eJ[u̕`
  If DrawBlock = -1 Or DrawBlock = i Then
  
    'n_
    lp = FO.Block(i).StartPoint
    For j = 0 To FO.Block(i).numCurve - 1
      
      With FO.Block(i).Curve(j)
        If .CType = TT_PRIM_LINE Then
          '܂̏ꍇ
          p(0).X = X + DScale * lp.X
          p(0).Y = Y + DScale * IIf(YMirror, 1 - lp.Y, lp.Y)
          
          For k = 0 To .numPoint - 1
            p(1 + k).X = X + DScale * .Point(k).X
            p(1 + k).Y = Y + DScale * IIf(YMirror, 1 - .Point(k).Y, .Point(k).Y)
          Next
          
          'Ō̃J[uȂn_ɖ߂
          If j = FO.Block(i).numCurve - 1 Then
            p(.numPoint + 1).X = X + DScale * FO.Block(i).StartPoint.X
            p(.numPoint + 1).Y = Y + DScale * IIf(YMirror, 1 - FO.Block(i).StartPoint.Y, FO.Block(i).StartPoint.Y)
            Call Polyline(hdc, p(0), .numPoint + 2)
          Else
            Call Polyline(hdc, p(0), .numPoint + 1)
          End If
        
        
        ElseIf .CType = TT_PRIM_QSPLINE Then
          'XvC̏ꍇ
          
          If .numPoint = 2 Then
            '_Q̏ꍇAP`
          
            'xWFȐ̎グ
            ps(0) = lp
            ps(1).X = lp.X / 3 + .Point(0).X * 2 / 3
            ps(1).Y = lp.Y / 3 + .Point(0).Y * 2 / 3
            ps(2).X = .Point(1).X / 3 + .Point(0).X * 2 / 3
            ps(2).Y = .Point(1).Y / 3 + .Point(0).Y * 2 / 3
            ps(3).X = .Point(1).X
            ps(3).Y = .Point(1).Y
            For k = 0 To 3
              p(k).X = X + DScale * ps(k).X
              p(k).Y = Y + DScale * IIf(YMirror, 1 - ps(k).Y, ps(k).Y)
            Next
            Call PolyBezier(hdc, p(0), 4)
          Else
            '_3ȏ̏ꍇAP,A,B,C,D,EƂ
            '(P,A,AB2),(AB2,B,BC2),(BC2,C,CD2),(CD2,D,E)ƕ`
            '(P,A,AB2)
            ps(0) = lp
            ps(1).X = lp.X / 3 + .Point(0).X * 2 / 3
            ps(1).Y = lp.Y / 3 + .Point(0).Y * 2 / 3
            ps(2).X = (.Point(0).X + .Point(1).X) / 6 + .Point(0).X * 2 / 3
            ps(2).Y = (.Point(0).Y + .Point(1).Y) / 6 + .Point(0).Y * 2 / 3
            ps(3).X = (.Point(0).X + .Point(1).X) / 2
            ps(3).Y = (.Point(0).Y + .Point(1).Y) / 2
            For k = 0 To 3
              p(k).X = X + DScale * ps(k).X
              p(k).Y = Y + DScale * IIf(YMirror, 1 - ps(k).Y, ps(k).Y)
            Next
            Call PolyBezier(hdc, p(0), 4)
            
            '(AB2,B,BC2),(BC2,C,CD2)
            For l = 0 To .numPoint - 4
              ps(0) = ps(3)
              ps(1).X = ps(3).X / 3 + .Point(l + 1).X * 2 / 3
              ps(1).Y = ps(3).Y / 3 + .Point(l + 1).Y * 2 / 3
              ps(2).X = (.Point(l + 1).X + .Point(l + 2).X) / 6 + .Point(l + 1).X * 2 / 3
              ps(2).Y = (.Point(l + 1).Y + .Point(l + 2).Y) / 6 + .Point(l + 1).Y * 2 / 3
              ps(3).X = (.Point(l + 1).X + .Point(l + 2).X) / 2
              ps(3).Y = (.Point(l + 1).Y + .Point(l + 2).Y) / 2
              For k = 0 To 3
                p(k).X = X + DScale * ps(k).X
                p(k).Y = Y + DScale * IIf(YMirror, 1 - ps(k).Y, ps(k).Y)
              Next
              Call PolyBezier(hdc, p(0), 4)
            Next
            '(CD2,D,E)
            ps(0) = ps(3)
            ps(1).X = ps(3).X / 3 + .Point(.numPoint - 2).X * 2 / 3
            ps(1).Y = ps(3).Y / 3 + .Point(.numPoint - 2).Y * 2 / 3
            ps(2).X = .Point(.numPoint - 1).X / 3 + .Point(.numPoint - 2).X * 2 / 3
            ps(2).Y = .Point(.numPoint - 1).Y / 3 + .Point(.numPoint - 2).Y * 2 / 3
            ps(3).X = .Point(.numPoint - 1).X
            ps(3).Y = .Point(.numPoint - 1).Y
            For k = 0 To 3
              p(k).X = X + DScale * ps(k).X
              p(k).Y = Y + DScale * IIf(YMirror, 1 - ps(k).Y, ps(k).Y)
            Next
            Call PolyBezier(hdc, p(0), 4)
            
            
            
          End If
          
          'Ō̃J[uȂn_ɂȂł
          If j = FO.Block(i).numCurve - 1 And .numPoint >= 2 Then
            p(0).X = X + DScale * .Point(.numPoint - 1).X
            p(0).Y = Y + DScale * IIf(YMirror, 1 - .Point(.numPoint - 1).Y, .Point(.numPoint - 1).Y)
            p(1).X = X + DScale * FO.Block(i).StartPoint.X
            p(1).Y = Y + DScale * IIf(YMirror, 1 - FO.Block(i).StartPoint.Y, FO.Block(i).StartPoint.Y)
            Call Polyline(hdc, p(0), 2)
          End If
          
                  
        End If
        
        lp = .Point(.numPoint - 1)
      End With
    Next
  End If
Next
    
'y폜
Call DeleteObject(SelectObject(hdc, oldPen))

End Sub

Sub FOScale(FO As FontOutline, ByVal X As Single, ByVal Y As Single, ByVal DScale As Single, ByVal YMirror As Boolean)
Dim i&, j&, k&

For i = 0 To FO.NumBlock - 1
  FO.Block(i).StartPoint.X = X + DScale * FO.Block(i).StartPoint.X
  FO.Block(i).StartPoint.Y = Y + DScale * IIf(YMirror, 1 - FO.Block(i).StartPoint.Y, FO.Block(i).StartPoint.Y)
  
  For j = 0 To FO.Block(i).numCurve - 1
    For k = 0 To FO.Block(i).Curve(j).numPoint - 1
      FO.Block(i).Curve(j).Point(k).X = X + DScale * FO.Block(i).Curve(j).Point(k).X
      FO.Block(i).Curve(j).Point(k).Y = Y + DScale * IIf(YMirror, 1 - FO.Block(i).Curve(j).Point(k).Y, FO.Block(i).Curve(j).Point(k).Y)
    Next
  Next
Next

End Sub


